# Load Balancing & Isoefficiency > Documents > References.md


## Description
All references to external logic. Includes anything from stack overflow links to notes about logic from previous works.


## References

### Parallelization
#### General Paralellization Logic
Most parallelization logic is from the book "Introduction to Parallel Programming, by Peter S Pancheco".

#### Getting Processor Count
<https://stackoverflow.com/a/47520857>

#### Checking if MPI Message is Present
<https://stackoverflow.com/a/38039050>

#### MPI Non-blocking Messages
* <https://www.clustermonkey.net/MPI/the-joys-of-asynchronous-communication.html>
* <http://www.mathcs.emory.edu/~cheung/Courses/561/Syllabus/92-MPI/async.html>

### Determining Seeming Inconsistencies in MPI Synchronization
* <http://www.oscer.ou.edu/ncsiworkshop2012intropar_mpiblockingnonblocking_murphy_20120803.pdf>
* <https://stackoverflow.com/questions/17582900/difference-between-mpi-send-and-mpi-ssend>

### MPI Async Functions
* Irecv - <https://www.open-mpi.org/doc/v3.1/man3/MPI_Irecv.3.php>
* Isend - <https://www.open-mpi.org/doc/v3.1/man3/MPI_Isend.3.php>
* Msg Buffer not Updating - <https://stackoverflow.com/a/42122170>
* MPI_Test - <https://mpi.deino.net/mpi_functions/MPI_Test.html>


### Data Types
#### Various C Data Types
<https://en.wikipedia.org/wiki/C_data_types>

#### Data Type Limits
<https://www.tutorialspoint.com/c_standard_library/limits_h.htm>


### Makefiles
#### Passing Command Line Args
<https://stackoverflow.com/a/47008498>


### Other
#### strtol Function
<https://www.tutorialspoint.com/c_standard_library/c_function_strtol.htm>

#### Pointer to Pointer
<https://www.tutorialspoint.com/cprogramming/c_pointer_to_pointer.htm>

#### Moving Cursor in Terminal
* <https://stackoverflow.com/a/35190285>
* <https://tldp.org/HOWTO/Bash-Prompt-HOWTO/x361.html>

#### Logging
* Create Dir - <https://stackoverflow.com/a/7430262>
* Write to File - <https://www.programiz.com/c-programming/examples/write-file>
* Getting File/LineNum:
** <https://stackoverflow.com/a/42135375>
** <https://stackoverflow.com/a/8884408>
* Function Macros - <https://gcc.gnu.org/onlinedocs/cpp/Function-like-Macros.html#Function-like-Macros>

#### Constants Between Files
* <https://stackoverflow.com/a/15531238>
* <https://stackoverflow.com/a/5499530>
